; Unterprogramm generiert die Meldungen fr die seriele Schnittstelle
; und wandelt das Statusbyte in ein HEX_ASCII-Wert um
;===============================================
;= UART Initialization                         =
;===============================================
UART_INIT:

.equ BAUD = 38400
.equ UBRRVAL = F_CPU/(BAUD*16)-1
; Baudrate einstellen
	ldi r16, LOW(UBRRVAL)
	out UBRRL, r16
	ldi r16, HIGH(UBRRVAL)
	out UBRRH, r16
; Frame-Format: 8 Bit
	ldi r16, (1<<URSEL)|(3<<UCSZ0)
	out UCSRC, r16
	sbi UCSRB,TXEN		; TX aktivieren
; Trennung	
	rcall rs_trennung
	rcall rs_trennung
ret
;===============================================
;= i2c_ini                                     =
;===============================================
rs_i2c_ini:
	ldi ZL, LOW(i2c_ini*2)
	ldi ZH, HIGH(i2c_ini*2)
	rcall print
	rcall zeilenumbruch
ret
;===============================================
;= i2c_start                                   =
;===============================================
rs_i2c_start:
	ldi ZL, LOW(i2c_start*2)
	ldi ZH, HIGH(i2c_start*2)
	rcall print
	rcall zeilenumbruch
ret

;===============================================
;= rs_i2c_daten                               =
;===============================================
rs_i2c_daten:
;Status Byte aufbereiten
	push Status			;Status Byte sichern
	push r16			;Hilfsregister sichern
	mov r16, Status		;Status Byte nach R16 kopieren
	andi Status, 0xf0	;unteres Nibble lschen
	swap Status			;Nibbles tauschen
	andi r16, 0x0f		;oberes Nibble vom Hilfsregister lschen 

;---- 1. Stelle  ----------------------------------------------------------
	cpi Status, 10      ;Vergleich ob Wert zwischen 0-9 oder A-F
	brge plus_37_1
	subi Status, 0xD0	;Addition des Offsetwertes 0x30 durch Subtraktion des 2er-Komplement
	rcall ausgabe_11	;Subtraktion spart Register, da Addition nur mit 2 Registern mglich ist
	rjmp Stelle_21
plus_37_1:
	subi Status, 0xC9	;Addition des Offsetwertes 0x37 durch Subtraktion des 2er-Komplement
	rcall ausgabe_11

;---- 2. Stelle  ----------------------------------------------------------
Stelle_21:
	cpi r16, 10
	brge plus_37_2
	subi r16, 0xD0
	rcall ausgabe_21
	rjmp end_bin_to_hex
plus_37_2:
	subi r16, 0xC9		
	rcall ausgabe_21


;---- Umwandlung fertig ---------------------------------------------------
end_bin_to_hex:
    rcall zeilenumbruch
	pop r16				;Hilfsregister zurckholen
	pop Status			;Status Byte zurckholen
ret
;------------------------------------------------------
;   Subroutine zu rs_i2c_daten
;------------------------------------------------------
ausgabe_11:
	mov r18, Status
	rcall sendbyte
ret

ausgabe_21:
	mov r18, r16
	rcall sendbyte
ret

;===============================================
;= i2c_slave                                   =
;===============================================
rs_i2c_slave:
	ldi ZL, LOW(i2c_slave*2)
	ldi ZH, HIGH(i2c_slave*2)
	rcall print
	rcall zeilenumbruch
ret
;===============================================
;= i2c_senden                                  =
;===============================================
rs_i2c_senden:
	ldi ZL, LOW(i2c_senden*2)
	ldi ZH, HIGH(i2c_senden*2)
	rcall print
	rcall zeilenumbruch
ret
;===============================================
;= i2c_empfang                                 =
;===============================================
rs_i2c_empfang:
	ldi ZL, LOW(i2c_empfang*2)
	ldi ZH, HIGH(i2c_empfang*2)
	rcall print
;	rcall zeilenumbruch
ret

;===============================================
;= i2c_status                                 =
;===============================================
rs_i2c_status:
	ldi ZL, LOW(i2c_status*2)
	ldi ZH, HIGH(i2c_status*2)
	rcall print
ret
;===============================================
;= i2c_stop                                    =
;===============================================
rs_i2c_stop:
	ldi ZL, LOW(i2c_stop*2)
	ldi ZH, HIGH(i2c_stop*2)
	rcall print
	rcall zeilenumbruch
ret
;===============================================
;= i2c_fehler                                    =
;===============================================
rs_i2c_fehler:
	ldi ZL, LOW(i2c_fehler*2)
	ldi ZH, HIGH(i2c_fehler*2)
	rcall print
	rcall zeilenumbruch
ret
;===============================================
;= rs_timer_an                                 =
;===============================================
rs_timer_an:
	ldi ZL, LOW(timer_an*2)
	ldi ZH, HIGH(timer_an*2)
	rcall print
	rcall zeilenumbruch
ret
;===============================================
;= rs_timer_aus                                =
;===============================================
rs_timer_aus:
	ldi ZL, LOW(timer_aus*2)
	ldi ZH, HIGH(timer_aus*2)
	rcall print
	rcall zeilenumbruch
ret
;===============================================
;= rs_trennung                                 =
;===============================================
rs_trennung:
	ldi ZL, LOW(trennung*2)
	ldi ZH, HIGH(trennung*2)
	rcall print
	rcall zeilenumbruch
ret
;===============================================
;= Zeilenumbruch                               =
;===============================================
zeilenumbruch: 
	ldi R18, 10			; die Bytes 10 und 13 senden
	rcall sendbyte		; (Zeilenumbruch im Terminal)
	ldi R18, 13
	rcall sendbyte
ret
;===============================================
;= Ausgabe Textbausteine                       =
;===============================================
print:
	lpm					; Erstes Byte des Strings nach R0 lesen
	tst R0				; R0 auf 0 testen
	breq print_end		; wenn 0, dann zu print_end
	mov r18, r0			; Inhalt von R0 nach R18 kopieren
	rcall sendbyte		; UART-Sendefunktion aufrufen
	adiw ZL, 1			; Adresse des Z-Pointers um 1 erhhen
	rjmp print			; wieder zum Anfang springen
print_end:
ret
;===============================================
;= URAT Ausgabe                                =
;===============================================
sendbyte:
	sbis UCSRA, UDRE	; warten bis das UART bereit ist
	rjmp sendbyte
	out UDR, R18
ret
;===============================================
;= Textbausteine fr RS-Dedug                  =
;===============================================
i2c_ini:		.db "TWI wurde initialisiert",0
i2c_start:		.db "Startkondition wurde gesendet",0
i2c_status:		.db "Status Code: ",0
i2c_slave:		.db "Slave Adresse uebermittelt ",0
i2c_senden:		.db "Daten wurden gesendet",0
i2c_empfang:	.db "Folgende Daten wurden empfangen: ",0
i2c_stop:		.db "Stopkondition wurde gesendet ",0
i2c_fehler:		.db "Es ist ein Fehler auf getreten!",0
;-----------------------------------------------
timer_an:		.db "Timer gestartet",0
timer_aus:		.db "Timer ausgeschaltet",0
trennung:		.db "-------------------------------",0
;-----------------------------------------------
